<script lang="ts">
  import YAML from 'yaml';
  import { page } from '$app/stores';
  import { Gql } from '@db';
  import { getVariablesList } from '@queries/variables';
  import { EventRole } from '@auth/models';
  import { keycloak } from '@stores';
  import { onMount } from 'svelte';
  import { Breadcrumb, BreadcrumbItem, Dropdown, DropdownItem, DropdownMenu, DropdownToggle, Table } from '@sveltestrap/sveltestrap';
  import type { CheckVariables, EventVariables, TeamVariables } from '@models/Variables';
  import { afterNavigate } from '$app/navigation';
  import requireRole from '@auth/PermissionRequired';
  import { faSliders } from '@fortawesome/free-solid-svg-icons';
  import Fa from 'svelte-fa';

  requireRole(EventRole.EventAdmin);
  let queryRole = $keycloak?.getFirstRole([EventRole.EventAdmin]);
  let vars: TeamVariables | CheckVariables | EventVariables;

  async function getVars() {
    const data = await Gql.query<{
      [`variables_${$page.params.type}`]: CheckVariables | EventVariables | TeamVariables;
    }>(`query AdminVariableDetailList ${getVariablesList($page.params.type)}`, {
      queryRole,
    });
    vars = data[`variables_${$page.params.type}`];
    console.log(vars);
  }

  onMount(getVars);
  afterNavigate(getVars);
</script>

<Breadcrumb>
  <BreadcrumbItem>Event Configuration</BreadcrumbItem>
  <BreadcrumbItem>
    <Dropdown setActiveFromChild>
      <DropdownToggle nav class="pe-2" caret>Variables</DropdownToggle>
      <DropdownMenu>
        <DropdownItem href="/admin/event-configuration/variables/check">
          <Fa icon={faSliders} /> Check Variables
        </DropdownItem>
        <DropdownItem href="/admin/event-configuration/variables/event">
          <Fa icon={faSliders} /> Event Variables
        </DropdownItem>
        <DropdownItem href="/admin/event-configuration/variables/team">
          <Fa icon={faSliders} /> Team Variables
        </DropdownItem>
      </DropdownMenu>
    </Dropdown>
  </BreadcrumbItem>
  <BreadcrumbItem active>
    {$page.params.type}
  </BreadcrumbItem>
</Breadcrumb>

<div class="my-4 mx-2">
  {#if vars}
    <Table>
      <thead>
        <td>Name</td>
        <td>Content</td>
      </thead>
      <tbody>
        {#each vars as entry}
          <tr>
            <td>
              <a href="/admin/event-configuration/variables/{$page.params.type}/{entry[`${$page.params.type}_id`]}">
                {entry[`${$page.params.type}`]?.name || entry[`${$page.params.type}_id`]}
              </a>
            </td>
            <td><pre>{YAML.stringify(entry.vars)}</pre></td>
          </tr>
        {/each}
      </tbody>
    </Table>
  {/if}
</div>
